package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.agent.models.AgentModel;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.models.Player;
import sk.fiit.jim.agent.models.WorldModel;
import sk.fiit.jim.decision.situation.BallAtMid;
import sk.fiit.jim.decision.situation.BallIsOurs;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

public class AvoidEnemy extends Tactic {
	
	public static final int TACTIC_STATE_ACT   = 1;
	public static final int TACTIC_STATE_IN_POSITION = 2;
	Vector3D agent = AgentModel.getInstance().getPosition();

	@Override
	public boolean getInitCondition(List<String> currentSituations) {
		return true;
	}

	@Override
	public boolean getProgressCondition(List<String> currentSituations) {
		return true;
	}
	@Override
	protected int checkState(List<String> currentSituations) {
		
		if ((agent.getX() > 3.5 && agent.getX() < 4.5)
				&& (agent.getY() > 1.5 && agent.getY() < 2.5)){
			System.out.println("TACTIC_STATE_IN_POSITION" + "");
			return TACTIC_STATE_IN_POSITION;
		}
		System.out.println("TACTIC_STATE_IN_POSITION" + "");
		return TACTIC_STATE_ACT;
	}

	@Override
	public void run() {
		
		if (currentState==TACTIC_STATE_ACT){
		double y_to_avoid=0;
		for (double i=-10;i<10;i++)
		{
			boolean yAvoidable = true;
			for(Player opt: WorldModel.getInstance().getOpponentPlayers())
			{
				if (opt.getPosition().getY()- i < 2){
					yAvoidable=false;
					break;
				};
			}
			if (yAvoidable==true && Math.abs(i)< y_to_avoid ){
				y_to_avoid = i;
			}
		}
		this.moveExec.move(Vector3D.cartesian(0,y_to_avoid,0),MovementSpeedEnum.WALK_MEDIUM);
		this.moveExec.move(Vector3D.cartesian(-7.2,0,0),MovementSpeedEnum.WALK_MEDIUM);
		}
		
		
	}

	@Override
	public List<String> getPrescribedSituations() {
		return new ArrayList<String>(Arrays.asList(BallAtMid.class.getName(),BallIsOurs.class.getName()));
	}

}
