package sk.fiit.jim.decision.tactic.tournament;

import sk.fiit.jim.agent.highskill.DefaultHighSkill;
import sk.fiit.jim.agent.highskill.GetUp;
import sk.fiit.jim.agent.highskill.runner.HighSkillPlanner;
import sk.fiit.jim.agent.highskill.runner.HighSkillRunner;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

import java.util.ArrayList;
import java.util.List;

/**
 * @author: Martin Adamik
 */
public class GetUpFromBacks extends Tactic {
    public static final int START_X = -3;
    public static final int START_Y = 0;
    public static final Vector3D TheyGoal = Vector3D.cartesian(15, 0, 0);
    public static final Vector3D OurGoal = Vector3D.cartesian(-15, 0, 0);

    protected int currentState = 1;
    
    HighSkillPlanner planner = HighSkillRunner.getPlanner();

    public boolean getInitCondition(List<String> currentSituations) {
        return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
        return false;
    }



    public List<String> getPrescribedSituations() {
        return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
        if (EnvironmentModel.beamablePlayMode() == true) {
            this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
            planner.addHighskillToQueue(new DefaultHighSkill("fall_back"));
            System.out.println("BEAM");
            planner.addHighskillToQueue(new GetUp());
            return;
        }
        if(currentState == 1) {
            this.run();
        }
    }

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

    @Override
    public void run() {
        currentState++;
    }

    @Override
    protected int checkState(List<String> currentSituations) {
        return 0;
    }
}

