package sk.fiit.jim.decision.tactic.tournament;

import sk.fiit.jim.agent.highskill.DefaultHighSkill;
import sk.fiit.jim.agent.highskill.GetUp;
import sk.fiit.jim.agent.highskill.move.MovementHighSkill;
import sk.fiit.jim.agent.highskill.runner.HighSkillPlanner;
import sk.fiit.jim.agent.highskill.runner.HighSkillRunner;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by delve on 29/05/14.
 */
public class GetUpFromStomach extends Tactic {
    public static final int START_X = -5;
    public static final int START_Y = 1;

    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
        return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
        return false;
    }



    public List<String> getPrescribedSituations() {
        return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
        if (EnvironmentModel.beamablePlayMode() == true) {
            this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
            HighSkillPlanner planner = HighSkillRunner.getPlanner();
            planner.addHighskillToQueue(new DefaultHighSkill("fall_front"));
            planner.addHighskillToQueue(new GetUp());
            System.out.println("BEAM");
            return;
        }
        if(currentState == 1) {
            this.run();
        }
    }

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

    @Override
    public void run() {
        currentState++;
    }

    @Override
    protected int checkState(List<String> currentSituations) {
        return 0;
    }
}
