package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.List;

import sk.fiit.jim.agent.highskill.DefaultHighSkill;
import sk.fiit.jim.agent.highskill.kick.KickHighSkill;
import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.agent.highskill.runner.HighSkillPlanner;
import sk.fiit.jim.agent.highskill.runner.HighSkillRunner;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.models.WorldModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 * Interface for defining tactic instances
 *
 * @author michal petras <michpet@gmail.com>
 * @year 2013/2014
 * @team RFC Megatroll
 */
public class KickDistance extends Tactic {


    public static final double START_X = -0.30;
    public static final double START_Y = 0;
    public static final Vector3D TheyGoal = Vector3D.cartesian(15, 0, 0);
 
    
    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
    	return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
    	return false;
    }

    
    
    public List<String> getPrescribedSituations() {
    	return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
		if (EnvironmentModel.beamablePlayMode() == true) {
			this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
			
			return;
		}
		if(currentState == 1) {
			this.run();
		}
	}

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

	@Override
	public void run() {
		 HighSkillPlanner planner = HighSkillRunner.getPlanner();

		currentState++;
	//k lopte
	// kop na branu (vzdialenost ... )
		planner.addHighskillToQueue(new DefaultHighSkill("kick_faster_left"));
		
	}

	@Override
	protected int checkState(List<String> currentSituations) {
		return 0;
	}

}
