package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.List;

import sk.fiit.jim.agent.highskill.kick.KickHighSkill;
import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.agent.models.DynamicObject;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.agent.models.WorldModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 * Interface for defining tactic instances
 *
 * @author michal ceresnak <micoken@gmail.com>
 * @year 2013/2014
 * @team RFC Megatroll
 */
public class KickOnGoal extends Tactic {


    public static final int START_X = -1;
    public static final int START_Y = 0;
    public static final Vector3D TheirGoal = Vector3D.cartesian(15, 0, 0);
    
    
    
    DynamicObject ball = WorldModel.getInstance().getBall();
	double ballX = ball.getPosition().getX();
    double ballY = ball.getPosition().getY();
    
    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
    	return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
    	return false;
    }

    
    
    public List<String> getPrescribedSituations() {
    	return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
		if (EnvironmentModel.beamablePlayMode() == true) {
			this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
			
			return;
		}
		if(currentState == 1) {
			this.run();
		}
	}

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

	@Override
	public void run() {
		
		currentState++;
		this.moveExec.move(MovementSpeedEnum.WALK_MEDIUM);
		this.kickExec.kick(TheirGoal, KickHighSkill.KickTypeEnum.KICK_NORMAL);	
	}

	@Override
	protected int checkState(List<String> currentSituations) {
		return 0;
	}
}
