package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.List;


import sk.fiit.jim.agent.highskill.kick.KickHighSkill;
import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 * Interface for defining tactic instances
 *
 * @author michal petras <michpet@gmail.com>
 * @year 2013/2014
 * @team RFC Megatroll
 */
public class KickOnXY extends Tactic {


    public static final int START_X = -3;
    public static final int START_Y = 1;
    public static final Vector3D TournamentPosition = Vector3D.cartesian(5, 5, 0);
    
    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
    	return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
    	return false;
    }

    
    
    public List<String> getPrescribedSituations() {
    	return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
		if (EnvironmentModel.beamablePlayMode() == true) {
			this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
			
			return;
		}
		if(currentState == 1) {
			this.run();
		}
	}

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

	@Override
	public void run() {
		
		currentState++;
	//k lopte
		this.moveExec.move(MovementSpeedEnum.WALK_MEDIUM);
	// kop na branu (vzdialenost ... )
		this.kickExec.kick(TournamentPosition, KickHighSkill.KickTypeEnum.KICK_STRONG);	
        
		
		
		
	}

	@Override
	protected int checkState(List<String> currentSituations) {
		return 0;
	}

}
