package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.List;
import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.agent.models.EnvironmentModel;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 * Interface for defining tactic instances
 *
 * @author Samuel Benkovic <sppred@gmail.com>, Vladimir Bosiak <vladimir.bosiak@gmail.com>
 * @year 2013/2014
 * @team RFC Megatroll
 */
public class StabilityWalkTactic extends Tactic {


    public static final int START_X = -5;
    public static final int START_Y = 1;
    
    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
    	return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
    	return false;
    }

    
    
    public List<String> getPrescribedSituations() {
    	return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
		if (EnvironmentModel.beamablePlayMode() == true) {
			this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
			System.out.println("BEAM");
			return;
		}
		if(currentState == 1) {
			this.run();
		}
	}

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

	@Override
	public void run() {
		currentState++;
		this.moveExec.move(Vector3D.cartesian(6, 1, 0),
				MovementSpeedEnum.WALK_MEDIUM);
	}

	@Override
	protected int checkState(List<String> currentSituations) {
		return 0;
	}

}
