package sk.fiit.jim.decision.tactic.tournament;

import java.util.ArrayList;
import java.util.List;

import sk.fiit.jim.agent.highskill.move.MovementHighSkill.MovementSpeedEnum;
import sk.fiit.jim.decision.tactic.Tactic;
import sk.fiit.robocup.library.geometry.Vector3D;

/**
 * Interface for defining tactic instances
 *
 * @author Samuel Benkovic <sppred@gmail.com>, Vladimir Bosiak <vladimir.bosiak@gmail.com>
 * @year 2013/2014
 * @team RFC Megatroll
 */
public class StaticTactic extends Tactic {


    public static final double START_X = -5.5;
    public static final double START_Y = -0.5;
    
    protected int currentState = 1;

    public boolean getInitCondition(List<String> currentSituations) {
    	return true;
    }

    public boolean getProgressCondition(List<String> currentSituations) {
    	return false;
    }

    
    
    public List<String> getPrescribedSituations() {
    	return (new ArrayList<String>());
    }

    public void startTactic(List<String> currentSituations) {
    	this.beamExec.BeamAgent(Vector3D.cartesian(START_X, START_Y, 0.1));
		System.out.println("BEAM");
	}

    public float getSuitability(List<String> currentSituations) {
        return 1;
    }

	@Override
	public void run() {
		currentState++;
		this.moveExec.move(Vector3D.cartesian(1, 1, 0),
				MovementSpeedEnum.WALK_FAST);
		this.moveExec.move(Vector3D.cartesian(1.25, 1, 0),
				MovementSpeedEnum.WALK_MEDIUM);
		this.moveExec.move(Vector3D.cartesian(6, 1, 0),
				MovementSpeedEnum.WALK_FAST);
	}

	@Override
	protected int checkState(List<String> currentSituations) {
		return 0;
	}

}
